maint.mk: generalize _gl_tight_scope for non-recursive make
[gnulib.git] / top / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2012 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Diagnostic for continued use of deprecated variable.
25 # Remove in 2013
26 ifneq ($(build_aux),)
27  $(error "$(ME): \
28 set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
29 endif
30
31 # Do not save the original name or timestamp in the .tar.gz file.
32 # Use --rsyncable if available.
33 gzip_rsyncable := \
34   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
35     && printf %s --rsyncable)
36 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
37
38 GIT = git
39 VC = $(GIT)
40
41 VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
42
43 # You can override this variable in cfg.mk to set your own regexp
44 # matching files to ignore.
45 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
46
47 # This is to preprocess robustly the output of $(VC_LIST), so that even
48 # when $(srcdir) is a pathological name like "....", the leading sed command
49 # removes only the intended prefix.
50 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
51
52 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
53 # when $(srcdir) is not ".".
54 ifeq ($(srcdir),.)
55 _prepend_srcdir_prefix =
56 else
57 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
58 endif
59
60 # In order to be able to consistently filter "."-relative names,
61 # (i.e., with no $(srcdir) prefix), this definition is careful to
62 # remove any $(srcdir) prefix, and to restore what it removes.
63 _sc_excl = \
64   $(or $(exclude_file_name_regexp--$@),^$$)
65 VC_LIST_EXCEPT = \
66   $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
67         | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
68           else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
69         | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
70         $(_prepend_srcdir_prefix)
71
72 ifeq ($(origin prev_version_file), undefined)
73   prev_version_file = $(srcdir)/.prev-version
74 endif
75
76 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
77 VERSION_REGEXP = $(subst .,\.,$(VERSION))
78 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
79
80 ifeq ($(VC),$(GIT))
81 this-vc-tag = v$(VERSION)
82 this-vc-tag-regexp = v$(VERSION_REGEXP)
83 else
84 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
85 tag-this-version = $(subst .,_,$(VERSION))
86 this-vc-tag = $(tag-package)-$(tag-this-version)
87 this-vc-tag-regexp = $(this-vc-tag)
88 endif
89 my_distdir = $(PACKAGE)-$(VERSION)
90
91 # Old releases are stored here.
92 release_archive_dir ?= ../release
93
94 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
95 # Use alpha.gnu.org for alpha and beta releases.
96 # Use ftp.gnu.org for stable releases.
97 gnu_ftp_host-alpha = alpha.gnu.org
98 gnu_ftp_host-beta = alpha.gnu.org
99 gnu_ftp_host-stable = ftp.gnu.org
100 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
101
102 ifeq ($(gnu_rel_host),ftp.gnu.org)
103 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
104 else
105 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
106 endif
107
108 # Override this in cfg.mk if you are using a different format in your
109 # NEWS file.
110 today = $(shell date +%Y-%m-%d)
111
112 # Select which lines of NEWS are searched for $(news-check-regexp).
113 # This is a sed line number spec.  The default says that we search
114 # lines 1..10 of NEWS for $(news-check-regexp).
115 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
116 news-check-lines-spec ?= 1,10
117 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
118
119 # Prevent programs like 'sort' from considering distinct strings to be equal.
120 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
121 export LC_ALL = C
122
123 ## --------------- ##
124 ## Sanity checks.  ##
125 ## --------------- ##
126
127 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
128
129 # Collect the names of rules starting with 'sc_'.
130 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
131                         $(srcdir)/$(ME) $(_cfg_mk)))
132 .PHONY: $(syntax-check-rules)
133
134 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
135 local-checks-available += $(syntax-check-rules)
136 else
137 local-checks-available += no-vc-detected
138 no-vc-detected:
139         @echo "No version control files detected; skipping syntax check"
140 endif
141 .PHONY: $(local-checks-available)
142
143 # Arrange to print the name of each syntax-checking rule just before running it.
144 $(syntax-check-rules): %: %.m
145 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
146 .PHONY: $(sc_m_rules_)
147 $(sc_m_rules_):
148         @echo $(patsubst sc_%.m, %, $@)
149         @date +%s.%N > .sc-start-$(basename $@)
150
151 # Compute and print the elapsed time for each syntax-check rule.
152 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
153 .PHONY: $(sc_z_rules_)
154 $(sc_z_rules_): %.z: %
155         @end=$$(date +%s.%N);                                           \
156         start=$$(cat .sc-start-$*);                                     \
157         rm -f .sc-start-$*;                                             \
158         awk -v s=$$start -v e=$$end                                     \
159           'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
160
161 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
162 # that computes and prints elapsed time.
163 local-check :=                                                          \
164   $(patsubst sc_%, sc_%.z,                                              \
165     $(filter-out $(local-checks-to-skip), $(local-checks-available)))
166
167 syntax-check: $(local-check)
168
169 # _sc_search_regexp
170 #
171 # This macro searches for a given construct in the selected files and
172 # then takes some action.
173 #
174 # Parameters (shell variables):
175 #
176 #  prohibit | require
177 #
178 #     Regular expression (ERE) denoting either a forbidden construct
179 #     or a required construct.  Those arguments are exclusive.
180 #
181 #  exclude
182 #
183 #     Regular expression (ERE) denoting lines to ignore that matched
184 #     a prohibit construct.  For example, this can be used to exclude
185 #     comments that mention why the nearby code uses an alternative
186 #     construct instead of the simpler prohibited construct.
187 #
188 #  in_vc_files | in_files
189 #
190 #     grep-E-style regexp selecting the files to check.  For in_vc_files,
191 #     the regexp is used to select matching files from the list of all
192 #     version-controlled files; for in_files, it's from the names printed
193 #     by "find $(srcdir)".  When neither is specified, use all files that
194 #     are under version control.
195 #
196 #  containing | non_containing
197 #
198 #     Select the files (non) containing strings matching this regexp.
199 #     If both arguments are specified then CONTAINING takes
200 #     precedence.
201 #
202 #  with_grep_options
203 #
204 #     Extra options for grep.
205 #
206 #  ignore_case
207 #
208 #     Ignore case.
209 #
210 #  halt
211 #
212 #     Message to display before to halting execution.
213 #
214 # Finally, you may exempt files based on an ERE matching file names.
215 # For example, to exempt from the sc_space_tab check all files with the
216 # .diff suffix, set this Make variable:
217 #
218 # exclude_file_name_regexp--sc_space_tab = \.diff$
219 #
220 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
221 # when filtering by name via in_files, we explicitly filter out matching
222 # names here as well.
223
224 # Initialize each, so that envvar settings cannot interfere.
225 export require =
226 export prohibit =
227 export exclude =
228 export in_vc_files =
229 export in_files =
230 export containing =
231 export non_containing =
232 export halt =
233 export with_grep_options =
234
235 # By default, _sc_search_regexp does not ignore case.
236 export ignore_case =
237 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
238
239 define _sc_say_and_exit
240    dummy=; : so we do not need a semicolon before each use;             \
241    { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
242 endef
243
244 define _sc_search_regexp
245    dummy=; : so we do not need a semicolon before each use;             \
246                                                                         \
247    : Check arguments;                                                   \
248    test -n "$$prohibit" && test -n "$$require"                          \
249      && { msg='Cannot specify both prohibit and require'                \
250           $(_sc_say_and_exit) } || :;                                   \
251    test -z "$$prohibit" && test -z "$$require"                          \
252      && { msg='Should specify either prohibit or require'               \
253           $(_sc_say_and_exit) } || :;                                   \
254    test -z "$$prohibit" && test -n "$$exclude"                          \
255      && { msg='Use of exclude requires a prohibit pattern'              \
256           $(_sc_say_and_exit) } || :;                                   \
257    test -n "$$in_vc_files" && test -n "$$in_files"                      \
258      && { msg='Cannot specify both in_vc_files and in_files'            \
259           $(_sc_say_and_exit) } || :;                                   \
260    test "x$$halt" != x                                                  \
261      || { msg='halt not defined' $(_sc_say_and_exit) };                 \
262                                                                         \
263    : Filter by file name;                                               \
264    if test -n "$$in_files"; then                                        \
265      files=$$(find $(srcdir) | grep -E "$$in_files"                     \
266               | grep -Ev '$(_sc_excl)');                                \
267    else                                                                 \
268      files=$$($(VC_LIST_EXCEPT));                                       \
269      if test -n "$$in_vc_files"; then                                   \
270        files=$$(echo "$$files" | grep -E "$$in_vc_files");              \
271      fi;                                                                \
272    fi;                                                                  \
273                                                                         \
274    : Filter by content;                                                 \
275    test -n "$$files" && test -n "$$containing"                          \
276      && { files=$$(grep -l "$$containing" $$files); } || :;             \
277    test -n "$$files" && test -n "$$non_containing"                      \
278      && { files=$$(grep -vl "$$non_containing" $$files); } || :;        \
279                                                                         \
280    : Check for the construct;                                           \
281    if test -n "$$files"; then                                           \
282      if test -n "$$prohibit"; then                                      \
283        grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
284          | grep -vE "$${exclude:-^$$}"                                  \
285          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
286      else                                                               \
287        grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
288            | grep .                                                     \
289          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
290      fi                                                                 \
291    else :;                                                              \
292    fi || :;
293 endef
294
295 sc_avoid_if_before_free:
296         @$(srcdir)/$(_build-aux)/useless-if-before-free                 \
297                 $(useless_free_options)                                 \
298             $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) &&   \
299           { echo '$(ME): found useless "if" before "free" above' 1>&2;  \
300             exit 1; } || :
301
302 sc_cast_of_argument_to_free:
303         @prohibit='\<free *\( *\(' halt="don't cast free argument"      \
304           $(_sc_search_regexp)
305
306 sc_cast_of_x_alloc_return_value:
307         @prohibit='\*\) *x(m|c|re)alloc\>'                              \
308         halt="don't cast x*alloc return value"                          \
309           $(_sc_search_regexp)
310
311 sc_cast_of_alloca_return_value:
312         @prohibit='\*\) *alloca\>'                                      \
313         halt="don't cast alloca return value"                           \
314           $(_sc_search_regexp)
315
316 sc_space_tab:
317         @prohibit='[ ]  '                                               \
318         halt='found SPACE-TAB sequence; remove the SPACE'               \
319           $(_sc_search_regexp)
320
321 # Don't use *scanf or the old ato* functions in "real" code.
322 # They provide no error checking mechanism.
323 # Instead, use strto* functions.
324 sc_prohibit_atoi_atof:
325         @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\('                           \
326         halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q'   \
327           $(_sc_search_regexp)
328
329 # Use STREQ rather than comparing strcmp == 0, or != 0.
330 sp_ = strcmp *\(.+\)
331 sc_prohibit_strcmp:
332         @prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)'         \
333         exclude='# *define STRN?EQ\('                                   \
334         halt='replace strcmp calls above with STREQ/STRNEQ'             \
335           $(_sc_search_regexp)
336
337 # Really.  You don't want to use this function.
338 # It may fail to NUL-terminate the destination,
339 # and always NUL-pads out to the specified length.
340 sc_prohibit_strncpy:
341         @prohibit='\<strncpy *\('                                       \
342         halt='do not use strncpy, period'                               \
343           $(_sc_search_regexp)
344
345 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
346 # Convert all uses automatically, via these two commands:
347 # git grep -l '\<exit *(1)' \
348 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
349 #  | xargs --no-run-if-empty \
350 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
351 # git grep -l '\<exit *(0)' \
352 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
353 #  | xargs --no-run-if-empty \
354 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
355 sc_prohibit_magic_number_exit:
356         @prohibit='(^|[^.])\<(usage|exit|error) ?\(-?[0-9]+[,)]'        \
357         exclude='exit \(77\)|error ?\(((0|77),|[^,]*)'                  \
358         halt='use EXIT_* values rather than magic number'               \
359           $(_sc_search_regexp)
360
361 # Using EXIT_SUCCESS as the first argument to error is misleading,
362 # since when that parameter is 0, error does not exit.  Use '0' instead.
363 sc_error_exit_success:
364         @prohibit='error *\(EXIT_SUCCESS,'                              \
365         in_vc_files='\.[chly]$$'                                        \
366         halt='found error (EXIT_SUCCESS'                                \
367          $(_sc_search_regexp)
368
369 # "FATAL:" should be fully upper-cased in error messages
370 # "WARNING:" should be fully upper-cased, or fully lower-cased
371 sc_error_message_warn_fatal:
372         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
373             | grep -E '"Warning|"Fatal|"fatal' &&                       \
374           { echo '$(ME): use FATAL, WARNING or warning' 1>&2;           \
375             exit 1; } || :
376
377 # Error messages should not start with a capital letter
378 sc_error_message_uppercase:
379         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
380             | grep -E '"[A-Z]'                                          \
381             | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' &&           \
382           { echo '$(ME): found capitalized error message' 1>&2;         \
383             exit 1; } || :
384
385 # Error messages should not end with a period
386 sc_error_message_period:
387         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
388             | grep -E '[^."]\."' &&                                     \
389           { echo '$(ME): found error message ending in period' 1>&2;    \
390             exit 1; } || :
391
392 sc_file_system:
393         @prohibit=file''system                                          \
394         ignore_case=1                                                   \
395         halt='found use of "file''system"; spell it "file system"'      \
396           $(_sc_search_regexp)
397
398 # Don't use cpp tests of this symbol.  All code assumes config.h is included.
399 sc_prohibit_have_config_h:
400         @prohibit='^# *if.*HAVE''_CONFIG_H'                             \
401         halt='found use of HAVE''_CONFIG_H; remove'                     \
402           $(_sc_search_regexp)
403
404 # Nearly all .c files must include <config.h>.  However, we also permit this
405 # via inclusion of a package-specific header, if cfg.mk specified one.
406 # config_h_header must be suitable for grep -E.
407 config_h_header ?= <config\.h>
408 sc_require_config_h:
409         @require='^# *include $(config_h_header)'                       \
410         in_vc_files='\.c$$'                                             \
411         halt='the above files do not include <config.h>'                \
412           $(_sc_search_regexp)
413
414 # You must include <config.h> before including any other header file.
415 # This can possibly be via a package-specific header, if given by cfg.mk.
416 sc_require_config_h_first:
417         @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then       \
418           fail=0;                                                       \
419           for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do             \
420             grep '^# *include\>' $$i | sed 1q                           \
421                 | grep -E '^# *include $(config_h_header)' > /dev/null  \
422               || { echo $$i; fail=1; };                                 \
423           done;                                                         \
424           test $$fail = 1 &&                                            \
425             { echo '$(ME): the above files include some other header'   \
426                 'before <config.h>' 1>&2; exit 1; } || :;               \
427         else :;                                                         \
428         fi
429
430 sc_prohibit_HAVE_MBRTOWC:
431         @prohibit='\bHAVE_MBRTOWC\b'                                    \
432         halt="do not use $$prohibit; it is always defined"              \
433           $(_sc_search_regexp)
434
435 # To use this "command" macro, you must first define two shell variables:
436 # h: the header name, with no enclosing <> or ""
437 # re: a regular expression that matches IFF something provided by $h is used.
438 define _sc_header_without_use
439   dummy=; : so we do not need a semicolon before each use;              \
440   h_esc=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`;                    \
441   if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then              \
442     files=$$(grep -l '^# *include '"$$h_esc"                            \
443              $$($(VC_LIST_EXCEPT) | grep '\.c$$')) &&                   \
444     grep -LE "$$re" $$files | grep . &&                                 \
445       { echo "$(ME): the above files include $$h but don't use it"      \
446         1>&2; exit 1; } || :;                                           \
447   else :;                                                               \
448   fi
449 endef
450
451 # Prohibit the inclusion of assert.h without an actual use of assert.
452 sc_prohibit_assert_without_use:
453         @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
454
455 # Prohibit the inclusion of close-stream.h without an actual use.
456 sc_prohibit_close_stream_without_use:
457         @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
458
459 # Prohibit the inclusion of getopt.h without an actual use.
460 sc_prohibit_getopt_without_use:
461         @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
462
463 # Don't include quotearg.h unless you use one of its functions.
464 sc_prohibit_quotearg_without_use:
465         @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
466
467 # Don't include quote.h unless you use one of its functions.
468 sc_prohibit_quote_without_use:
469         @h='quote.h' re='\<quote((_n)? *\(|_quoting_options\>)' \
470           $(_sc_header_without_use)
471
472 # Don't include this header unless you use one of its functions.
473 sc_prohibit_long_options_without_use:
474         @h='long-options.h' re='\<parse_long_options *\(' \
475           $(_sc_header_without_use)
476
477 # Don't include this header unless you use one of its functions.
478 sc_prohibit_inttostr_without_use:
479         @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
480           $(_sc_header_without_use)
481
482 # Don't include this header unless you use one of its functions.
483 sc_prohibit_ignore_value_without_use:
484         @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
485           $(_sc_header_without_use)
486
487 # Don't include this header unless you use one of its functions.
488 sc_prohibit_error_without_use:
489         @h='error.h' \
490         re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
491           $(_sc_header_without_use)
492
493 # Don't include xalloc.h unless you use one of its functions.
494 # Consider these symbols:
495 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
496 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
497 # Divide into two sets on case, and filter each through this:
498 # | sort | perl -MRegexp::Assemble -le \
499 #  'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
500 # Note this was produced by the above:
501 # _xa1 = \
502 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
503 # But we can do better, in at least two ways:
504 # 1) take advantage of two "dup"-suffixed strings:
505 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
506 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
507 # "char|[cmz]"
508 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
509 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
510 _xa2 = X([CZ]|N?M)ALLOC
511 sc_prohibit_xalloc_without_use:
512         @h='xalloc.h' \
513         re='\<($(_xa1)|$(_xa2)) *\('\
514           $(_sc_header_without_use)
515
516 # Extract function names:
517 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
518 _hash_re = \
519 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
520 _hash_fn = \<($(_hash_re)) *\(
521 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
522 sc_prohibit_hash_without_use:
523         @h='hash.h' \
524         re='$(_hash_fn)|$(_hash_struct)'\
525           $(_sc_header_without_use)
526
527 sc_prohibit_cloexec_without_use:
528         @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
529           $(_sc_header_without_use)
530
531 sc_prohibit_posixver_without_use:
532         @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
533
534 sc_prohibit_same_without_use:
535         @h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
536
537 sc_prohibit_hash_pjw_without_use:
538         @h='hash-pjw.h' \
539         re='\<hash_pjw\>' \
540           $(_sc_header_without_use)
541
542 sc_prohibit_safe_read_without_use:
543         @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
544           $(_sc_header_without_use)
545
546 sc_prohibit_argmatch_without_use:
547         @h='argmatch.h' \
548         re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
549           $(_sc_header_without_use)
550
551 sc_prohibit_canonicalize_without_use:
552         @h='canonicalize.h' \
553         re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
554           $(_sc_header_without_use)
555
556 sc_prohibit_root_dev_ino_without_use:
557         @h='root-dev-ino.h' \
558         re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
559           $(_sc_header_without_use)
560
561 sc_prohibit_openat_without_use:
562         @h='openat.h' \
563         re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
564           $(_sc_header_without_use)
565
566 # Prohibit the inclusion of c-ctype.h without an actual use.
567 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
568 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
569 sc_prohibit_c_ctype_without_use:
570         @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
571           $(_sc_header_without_use)
572
573 _empty =
574 _sp = $(_empty) $(_empty)
575 # The following list was generated by running:
576 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
577 #   | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
578 _sig_functions = \
579   bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
580   sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
581   siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
582   sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
583 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
584 # The following were extracted from "man signal.h" manually.
585 _sig_types_and_consts =                                                 \
586   MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK           \
587   SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL            \
588   SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE    \
589   SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t  \
590   sigstack sigval stack_t ucontext_t
591 # generated via this:
592 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
593 _sig_names =                                                            \
594   SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT      \
595   SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL       \
596   SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP  \
597   SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR      \
598   SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS   \
599   SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1        \
600   SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW       \
601   SIGXCPU SIGXFSZ
602 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
603
604 # Prohibit the inclusion of signal.h without an actual use.
605 sc_prohibit_signal_without_use:
606         @h='signal.h'                                                   \
607         re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>'          \
608           $(_sc_header_without_use)
609
610 # Don't include stdio--.h unless you use one of its functions.
611 sc_prohibit_stdio--_without_use:
612         @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\('              \
613           $(_sc_header_without_use)
614
615 # Don't include stdio-safer.h unless you use one of its functions.
616 sc_prohibit_stdio-safer_without_use:
617         @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\('    \
618           $(_sc_header_without_use)
619
620 # Prohibit the inclusion of strings.h without a sensible use.
621 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
622 sc_prohibit_strings_without_use:
623         @h='strings.h'                                                  \
624         re='\<(strn?casecmp|ffs(ll)?)\>'                                \
625           $(_sc_header_without_use)
626
627 # Get the list of symbol names with this:
628 # perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
629 _intprops_names =                                                       \
630   TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT             \
631   TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM           \
632   INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND              \
633   INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW                    \
634   INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW                 \
635   INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW                \
636   INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW  \
637   INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW         \
638   INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
639 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
640 # Prohibit the inclusion of intprops.h without an actual use.
641 sc_prohibit_intprops_without_use:
642         @h='intprops.h'                                                 \
643         re='\<($(_intprops_syms_re)) *\('                               \
644           $(_sc_header_without_use)
645
646 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
647 # Prohibit the inclusion of stddef.h without an actual use.
648 sc_prohibit_stddef_without_use:
649         @h='stddef.h'                                                   \
650         re='\<($(_stddef_syms_re))\>'                                   \
651           $(_sc_header_without_use)
652
653 _de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
654 _de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
655 _de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
656 _dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
657 # Prohibit the inclusion of dirent.h without an actual use.
658 sc_prohibit_dirent_without_use:
659         @h='dirent.h'                                                   \
660         re='\<($(_dirent_syms_re))\>'                                   \
661           $(_sc_header_without_use)
662
663 # Prohibit the inclusion of verify.h without an actual use.
664 sc_prohibit_verify_without_use:
665         @h='verify.h'                                                   \
666         re='\<(verify(true|expr)?|static_assert) *\('                   \
667           $(_sc_header_without_use)
668
669 # Don't include xfreopen.h unless you use one of its functions.
670 sc_prohibit_xfreopen_without_use:
671         @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
672
673 sc_obsolete_symbols:
674         @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                     \
675         halt='do not use HAVE''_FCNTL_H or O'_NDELAY                    \
676           $(_sc_search_regexp)
677
678 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
679
680 # Each nonempty ChangeLog line must start with a year number, or a TAB.
681 sc_changelog:
682         @prohibit='^[^12        ]'                                      \
683         in_vc_files='^ChangeLog$$'                                      \
684         halt='found unexpected prefix in a ChangeLog'                   \
685           $(_sc_search_regexp)
686
687 # Ensure that each .c file containing a "main" function also
688 # calls set_program_name.
689 sc_program_name:
690         @require='set_program_name *\(m?argv\[0\]\);'                   \
691         in_vc_files='\.c$$'                                             \
692         containing='\<main *('                                          \
693         halt='the above files do not call set_program_name'             \
694           $(_sc_search_regexp)
695
696 # Ensure that each .c file containing a "main" function also
697 # calls bindtextdomain.
698 sc_bindtextdomain:
699         @require='bindtextdomain *\('                                   \
700         in_vc_files='\.c$$'                                             \
701         containing='\<main *('                                          \
702         halt='the above files do not call bindtextdomain'               \
703           $(_sc_search_regexp)
704
705 # Require that the final line of each test-lib.sh-using test be this one:
706 # Exit $fail
707 # Note: this test requires GNU grep's --label= option.
708 Exit_witness_file ?= tests/test-lib.sh
709 Exit_base := $(notdir $(Exit_witness_file))
710 sc_require_test_exit_idiom:
711         @if test -f $(srcdir)/$(Exit_witness_file); then                \
712           die=0;                                                        \
713           for i in $$(grep -l -F 'srcdir/$(Exit_base)'                  \
714                 $$($(VC_LIST) tests)); do                               \
715             tail -n1 $$i | grep '^Exit .' > /dev/null                   \
716               && : || { die=1; echo $$i; }                              \
717           done;                                                         \
718           test $$die = 1 &&                                             \
719             { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
720               echo 1>&2 'Exit something';                               \
721               exit 1; } || :;                                           \
722         fi
723
724 sc_trailing_blank:
725         @prohibit='[     ]$$'                                           \
726         halt='found trailing blank(s)'                                  \
727         exclude='^Binary file .* matches$$'                             \
728           $(_sc_search_regexp)
729
730 # Match lines like the following, but where there is only one space
731 # between the options and the description:
732 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
733 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
734 sc_two_space_separator_in_usage:
735         @prohibit='^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
736         halt='help2man requires at least two spaces between an option and its description'\
737           $(_sc_search_regexp)
738
739 # A regexp matching function names like "error" that may be used
740 # to emit translatable messages.
741 _gl_translatable_diag_func_re ?= error
742
743 # Look for diagnostics that aren't marked for translation.
744 # This won't find any for which error's format string is on a separate line.
745 sc_unmarked_diagnostics:
746         @prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
747         exclude='(_|ngettext ?)\('                                      \
748         halt='found unmarked diagnostic(s)'                             \
749           $(_sc_search_regexp)
750
751 # Avoid useless parentheses like those in this example:
752 # #if defined (SYMBOL) || defined (SYM2)
753 sc_useless_cpp_parens:
754         @prohibit='^# *if .*defined *\('                                \
755         halt='found useless parentheses in cpp directive'               \
756           $(_sc_search_regexp)
757
758 # List headers for which HAVE_HEADER_H is always true, assuming you are
759 # using the appropriate gnulib module.  CAUTION: for each "unnecessary"
760 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
761 # requires the gnulib module that guarantees the usability of that header.
762 gl_assured_headers_ = \
763   cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
764
765 # Convert the list of names to upper case, and replace each space with "|".
766 az_ = abcdefghijklmnopqrstuvwxyz
767 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
768 gl_header_upper_case_or_ =                                              \
769   $$($(gl_assured_headers_)                                             \
770     | tr $(az_)/.- $(AZ_)___                                            \
771     | tr -s ' ' '|'                                                     \
772     )
773 sc_prohibit_always_true_header_tests:
774         @or=$(gl_header_upper_case_or_);                                \
775         re="HAVE_($$or)_H";                                             \
776         prohibit='\<'"$$re"'\>'                                         \
777         halt=$$(printf '%s\n'                                           \
778         'do not test the above HAVE_<header>_H symbol(s);'              \
779         '  with the corresponding gnulib module, they are always true') \
780           $(_sc_search_regexp)
781
782 sc_prohibit_defined_have_decl_tests:
783         @prohibit='#[    ]*if(n?def|.*\<defined)\>[      (]+HAVE_DECL_' \
784         halt='HAVE_DECL macros are always defined'                      \
785           $(_sc_search_regexp)
786
787 # ==================================================================
788 gl_other_headers_ ?= \
789   intprops.h    \
790   openat.h      \
791   stat-macros.h
792
793 # Perl -lne code to extract "significant" cpp-defined symbols from a
794 # gnulib header file, eliminating a few common false-positives.
795 # The exempted names below are defined only conditionally in gnulib,
796 # and hence sometimes must/may be defined in application code.
797 gl_extract_significant_defines_ = \
798   /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
799     && $$2 !~ /(?:rpl_|_used_without_)/\
800     && $$1 !~ /^(?:NSIG|ENODATA)$$/\
801     && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
802     and print $$1
803
804 # Create a list of regular expressions matching the names
805 # of macros that are guaranteed to be defined by parts of gnulib.
806 define def_sym_regex
807         gen_h=$(gl_generated_headers_);                                 \
808         (cd $(gnulib_dir)/lib;                                          \
809           for f in *.in.h $(gl_other_headers_); do                      \
810             test -f $$f                                                 \
811               && perl -lne '$(gl_extract_significant_defines_)' $$f;    \
812           done;                                                         \
813         ) | sort -u                                                     \
814           | sed 's/^/^ *# *(define|undef)  */;s/$$/\\>/'
815 endef
816
817 # Don't define macros that we already get from gnulib header files.
818 sc_prohibit_always-defined_macros:
819         @if test -d $(gnulib_dir); then                                 \
820           case $$(echo all: | grep -l -f - Makefile) in Makefile);; *)  \
821             echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
822           esac;                                                         \
823           $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT))         \
824             && { echo '$(ME): define the above via some gnulib .h file' \
825                   1>&2;  exit 1; } || :;                                \
826         fi
827 # ==================================================================
828
829 # Prohibit checked in backup files.
830 sc_prohibit_backup_files:
831         @$(VC_LIST) | grep '~$$' &&                             \
832           { echo '$(ME): found version controlled backup file' 1>&2;    \
833             exit 1; } || :
834
835 # Require the latest GPL.
836 sc_GPL_version:
837         @prohibit='either ''version [^3]'                               \
838         halt='GPL vN, N!=3'                                             \
839           $(_sc_search_regexp)
840
841 # Require the latest GFDL.  Two regexp, since some .texi files end up
842 # line wrapping between 'Free Documentation License,' and 'Version'.
843 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
844 sc_GFDL_version:
845         @prohibit='$(_GFDL_regexp)'                                     \
846         halt='GFDL vN, N!=3'                                            \
847           $(_sc_search_regexp)
848
849 # Don't use Texinfo's @acronym{}.
850 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
851 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
852 sc_texinfo_acronym:
853         @prohibit='@acronym\{'                                          \
854         in_vc_files='$(texinfo_suffix_re_)'                             \
855         halt='found use of Texinfo @acronym{}'                          \
856           $(_sc_search_regexp)
857
858 cvs_keywords = \
859   Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
860
861 sc_prohibit_cvs_keyword:
862         @prohibit='\$$($(cvs_keywords))\$$'                             \
863         halt='do not use CVS keyword expansion'                         \
864           $(_sc_search_regexp)
865
866 # This Perl code is slightly obfuscated.  Not only is each "$" doubled
867 # because it's in a Makefile, but the $$c's are comments;  we cannot
868 # use "#" due to the way the script ends up concatenated onto one line.
869 # It would be much more concise, and would produce better output (including
870 # counts) if written as:
871 #   perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
872 # but that would be far less efficient, reading the entire contents
873 # of each file, rather than just the last two bytes of each.
874 # In addition, while the code below detects both blank lines and a missing
875 # newline at EOF, the above detects only the former.
876 #
877 # This is a perl script that is expected to be the single-quoted argument
878 # to a command-line "-le".  The remaining arguments are file names.
879 # Print the name of each file that does not end in exactly one newline byte.
880 # I.e., warn if there are blank lines (2 or more newlines), or if the
881 # last byte is not a newline.  However, currently we don't complain
882 # about any file that contains exactly one byte.
883 # Exit nonzero if at least one such file is found, otherwise, exit 0.
884 # Warn about, but otherwise ignore open failure.  Ignore seek/read failure.
885 #
886 # Use this if you want to remove trailing empty lines from selected files:
887 #   perl -pi -0777 -e 's/\n\n+$/\n/' files...
888 #
889 require_exactly_one_NL_at_EOF_ =                                        \
890   foreach my $$f (@ARGV)                                                \
891     {                                                                   \
892       open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next;     \
893       my $$p = sysseek (F, -2, 2);                                      \
894       my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
895       my $$last_two_bytes;                                              \
896       defined $$p and $$p = sysread F, $$last_two_bytes, 2;             \
897       close F;                                                          \
898       $$c = "ignore read failure";                                      \
899       $$p && ($$last_two_bytes eq "\n\n"                                \
900               || substr ($$last_two_bytes,1) ne "\n")                   \
901           and (print $$f), $$fail=1;                                    \
902     }                                                                   \
903   END { exit defined $$fail }
904 sc_prohibit_empty_lines_at_EOF:
905         @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
906           || { echo '$(ME): empty line(s) or no newline at EOF'         \
907                 1>&2; exit 1; } || :
908
909 # Make sure we don't use st_blocks.  Use ST_NBLOCKS instead.
910 # This is a bit of a kludge, since it prevents use of the string
911 # even in comments, but for now it does the job with no false positives.
912 sc_prohibit_stat_st_blocks:
913         @prohibit='[.>]st_blocks'                                       \
914         halt='do not use st_blocks; use ST_NBLOCKS'                     \
915           $(_sc_search_regexp)
916
917 # Make sure we don't define any S_IS* macros in src/*.c files.
918 # They're already defined via gnulib's sys/stat.h replacement.
919 sc_prohibit_S_IS_definition:
920         @prohibit='^ *# *define  *S_IS'                                 \
921         halt='do not define S_IS* macros; include <sys/stat.h>'         \
922           $(_sc_search_regexp)
923
924 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
925 # that is shared by two definitions below.
926 perl_filename_lineno_text_ =                                            \
927     -e '  {'                                                            \
928     -e '    $$n = ($$` =~ tr/\n/\n/ + 1);'                              \
929     -e '    ($$v = $$&) =~ s/\n/\\n/g;'                                 \
930     -e '    print "$$ARGV:$$n:$$v\n";'                                  \
931     -e '  }'
932
933 prohibit_doubled_word_RE_ ?= \
934   /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
935 prohibit_doubled_word_ =                                                \
936     -e 'while ($(prohibit_doubled_word_RE_))'                           \
937     $(perl_filename_lineno_text_)
938
939 # Define this to a regular expression that matches
940 # any filename:dd:match lines you want to ignore.
941 # The default is to ignore no matches.
942 ignore_doubled_word_match_RE_ ?= ^$$
943
944 sc_prohibit_doubled_word:
945         @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT))  \
946           | grep -vE '$(ignore_doubled_word_match_RE_)'                 \
947           | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
948
949 # A regular expression matching undesirable combinations of words like
950 # "can not"; this matches them even when the two words appear on different
951 # lines, but not when there is an intervening delimiter like "#" or "*".
952 # Similarly undesirable, "See @xref{...}", since an @xref should start
953 # a sentence.  Explicitly prohibit any prefix of "see" or "also".
954 # Also prohibit a prefix matching "\w+ +".
955 # @pxref gets the same see/also treatment and should be parenthesized;
956 # presume it must *not* start a sentence.
957 bad_xref_re_ ?= (?:[\w,:;] +|(?:see|also)\s+)\@xref\{
958 bad_pxref_re_ ?= (?:[.!?]|(?:see|also))\s+\@pxref\{
959 prohibit_undesirable_word_seq_RE_ ?=                                    \
960   /(?:\bcan\s+not\b|$(bad_xref_re_)|$(bad_pxref_re_))/gims
961 prohibit_undesirable_word_seq_ =                                        \
962     -e 'while ($(prohibit_undesirable_word_seq_RE_))'                   \
963     $(perl_filename_lineno_text_)
964 # Define this to a regular expression that matches
965 # any filename:dd:match lines you want to ignore.
966 # The default is to ignore no matches.
967 ignore_undesirable_word_sequence_RE_ ?= ^$$
968
969 sc_prohibit_undesirable_word_seq:
970         @perl -n -0777 $(prohibit_undesirable_word_seq_)                \
971              $$($(VC_LIST_EXCEPT))                                      \
972           | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
973           && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
974
975 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
976 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
977 # Using test's -a and -o operators is not portable.
978 # We prefer test over [, since the latter is spelled [[ in configure.ac.
979 sc_prohibit_test_minus_ao:
980         @prohibit='(\<test| \[+) .+ -[ao] '                             \
981         halt='$(_ptm1); $(_ptm2)'                                       \
982           $(_sc_search_regexp)
983
984 # Avoid a test bashism.
985 sc_prohibit_test_double_equal:
986         @prohibit='(\<test| \[+) .+ == '                                \
987         containing='#! */bin/[a-z]*sh'                                  \
988         halt='use "test x = x", not "test x =''= x"'                    \
989           $(_sc_search_regexp)
990
991 # Each program that uses proper_name_utf8 must link with one of the
992 # ICONV libraries.  Otherwise, some ICONV library must appear in LDADD.
993 # The perl -0777 invocation below extracts the possibly-multi-line
994 # definition of LDADD from the appropriate Makefile.am and exits 0
995 # when it contains "ICONV".
996 sc_proper_name_utf8_requires_ICONV:
997         @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
998         if test "x$$progs" != x; then                                   \
999           fail=0;                                                       \
1000           for p in $$progs; do                                          \
1001             dir=$$(dirname "$$p");                                      \
1002             perl -0777                                                  \
1003               -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)'  \
1004               $$dir/Makefile.am && continue;                            \
1005             base=$$(basename "$$p" .c);                                 \
1006             grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
1007               || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
1008           done;                                                         \
1009           test $$fail = 1 &&                                            \
1010             { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
1011               exit 1; } || :;                                           \
1012         fi
1013
1014 # Warn about "c0nst struct Foo const foo[]",
1015 # but not about "char const *const foo" or "#define const const".
1016 sc_redundant_const:
1017         @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b'          \
1018         halt='redundant "const" in declarations'                        \
1019           $(_sc_search_regexp)
1020
1021 sc_const_long_option:
1022         @prohibit='^ *static.*struct option '                           \
1023         exclude='const struct option|struct option const'               \
1024         halt='add "const" to the above declarations'                    \
1025           $(_sc_search_regexp)
1026
1027 NEWS_hash =                                                             \
1028   $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p'              \
1029        $(srcdir)/NEWS                                                   \
1030      | perl -0777 -pe                                                   \
1031         's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms'       \
1032      | md5sum -                                                         \
1033      | sed 's/ .*//')
1034
1035 # Ensure that we don't accidentally insert an entry into an old NEWS block.
1036 sc_immutable_NEWS:
1037         @if test -f $(srcdir)/NEWS; then                                \
1038           test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : ||              \
1039             { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
1040         fi
1041
1042 # Update the hash stored above.  Do this after each release and
1043 # for any corrections to old entries.
1044 update-NEWS-hash: NEWS
1045         perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1046           $(srcdir)/cfg.mk
1047
1048 # Ensure that we use only the standard $(VAR) notation,
1049 # not @...@ in Makefile.am, now that we can rely on automake
1050 # to emit a definition for each substituted variable.
1051 # However, there is still one case in which @VAR@ use is not just
1052 # legitimate, but actually required: when augmenting an automake-defined
1053 # variable with a prefix.  For example, gettext uses this:
1054 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1055 # otherwise, makeinfo would put German or French (current locale)
1056 # navigation hints in the otherwise-English documentation.
1057 #
1058 # Allow the package to add exceptions via a hook in cfg.mk;
1059 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1060 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1061 _makefile_at_at_check_exceptions ?=
1062 sc_makefile_at_at_check:
1063         @perl -ne '/\@\w+\@/'                                           \
1064           -e ' && !/(\w+)\s+=.*\@\1\@$$/'                               \
1065           -e ''$(_makefile_at_at_check_exceptions)                      \
1066           -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}'    \
1067             $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1068           && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1069
1070 news-check: NEWS
1071         $(AM_V_GEN)if sed -n $(news-check-lines-spec)p $<               \
1072             | grep -E $(news-check-regexp) >/dev/null; then             \
1073           :;                                                            \
1074         else                                                            \
1075           echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2;      \
1076           exit 1;                                                       \
1077         fi
1078
1079 sc_makefile_TAB_only_indentation:
1080         @prohibit='^    [ ]{8}'                                         \
1081         in_vc_files='akefile|\.mk$$'                                    \
1082         halt='found TAB-8-space indentation'                            \
1083           $(_sc_search_regexp)
1084
1085 sc_m4_quote_check:
1086         @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]'              \
1087         in_vc_files='(^configure\.ac|\.m4)$$'                           \
1088         halt='quote the first arg to AC_DEF*'                           \
1089           $(_sc_search_regexp)
1090
1091 fix_po_file_diag = \
1092 'you have changed the set of files with translatable diagnostics;\n\
1093 apply the above patch\n'
1094
1095 # Verify that all source files using _() are listed in po/POTFILES.in.
1096 po_file ?= $(srcdir)/po/POTFILES.in
1097 generated_files ?= $(srcdir)/lib/*.[ch]
1098 sc_po_check:
1099         @if test -f $(po_file); then                                    \
1100           grep -E -v '^(#|$$)' $(po_file)                               \
1101             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
1102           files=;                                                       \
1103           for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do      \
1104             test -r $$file || continue;                                 \
1105             case $$file in                                              \
1106               *.m4|*.mk) continue ;;                                    \
1107               *.?|*.??) ;;                                              \
1108               *) continue;;                                             \
1109             esac;                                                       \
1110             case $$file in                                              \
1111             *.[ch])                                                     \
1112               base=`expr " $$file" : ' \(.*\)\..'`;                     \
1113               { test -f $$base.l || test -f $$base.y; } && continue;;   \
1114             esac;                                                       \
1115             files="$$files $$file";                                     \
1116           done;                                                         \
1117           grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files          \
1118             | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2;      \
1119           diff -u -L $(po_file) -L $(po_file) $@-1 $@-2                 \
1120             || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; };   \
1121           rm -f $@-1 $@-2;                                              \
1122         fi
1123
1124 # Sometimes it is useful to change the PATH environment variable
1125 # in Makefiles.  When doing so, it's better not to use the Unix-centric
1126 # path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
1127 msg = 'Do not use ":" above; use $$(PATH_SEPARATOR) instead'
1128 sc_makefile_path_separator_check:
1129         @prohibit='PATH[=].*:'                                          \
1130         in_vc_files='akefile|\.mk$$'                                    \
1131         halt=$(msg)                                                     \
1132           $(_sc_search_regexp)
1133
1134 # Check that 'make alpha' will not fail at the end of the process,
1135 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1136 # and is read-only.
1137 writable-files:
1138         if test -d $(release_archive_dir); then                         \
1139           for file in $(DIST_ARCHIVES); do                              \
1140             for p in ./ $(release_archive_dir)/; do                     \
1141               test -e $$p$$file || continue;                            \
1142               test -w $$p$$file                                         \
1143                 || { echo ERROR: $$p$$file is not writable; fail=1; };  \
1144             done;                                                       \
1145           done;                                                         \
1146           test "$$fail" && exit 1 || : ;                                \
1147         else :;                                                         \
1148         fi
1149
1150 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1151 sample-test = tests/sample-test
1152 texi = doc/$(PACKAGE).texi
1153 # Make sure that the copyright date in $(v_etc_file) is up to date.
1154 # Do the same for the $(sample-test) and the main doc/.texi file.
1155 sc_copyright_check:
1156         @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };'            \
1157         in_files=$(v_etc_file)                                          \
1158         halt='out of date copyright in $(v_etc_file); update it'        \
1159           $(_sc_search_regexp)
1160         @require='# Copyright \(C\) '$$(date +%Y)' Free'                \
1161         in_vc_files=$(sample-test)                                      \
1162         halt='out of date copyright in $(sample-test); update it'       \
1163           $(_sc_search_regexp)
1164         @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free'       \
1165         in_vc_files=$(texi)                                             \
1166         halt='out of date copyright in $(texi); update it'              \
1167           $(_sc_search_regexp)
1168
1169 # If tests/help-version exists and seems to be new enough, assume that its
1170 # use of init.sh and path_prepend_ is correct, and ensure that every other
1171 # use of init.sh is identical.
1172 # This is useful because help-version cross-checks prog --version
1173 # with $(VERSION), which verifies that its path_prepend_ invocation
1174 # sets PATH correctly.  This is an inexpensive way to ensure that
1175 # the other init.sh-using tests also get it right.
1176 _hv_file ?= $(srcdir)/tests/help-version
1177 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1178 # Fix syntax-highlighters "
1179 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1180 sc_cross_check_PATH_usage_in_tests:
1181         @if test -f $(_hv_file); then                                   \
1182           grep -l 'VERSION mismatch' $(_hv_file) >/dev/null             \
1183             || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2;    \
1184                  exit 0; };                                             \
1185           grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null         \
1186             || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1187                  exit 1; };                                             \
1188           good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file));           \
1189           grep -LFx "$$good"                                            \
1190                 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT)))  \
1191               | grep . &&                                               \
1192             { echo "$(ME): the above files use path_prepend_ inconsistently" \
1193                 1>&2; exit 1; } || :;                                   \
1194         fi
1195
1196 # BRE regex of file contents to identify a test script.
1197 _test_script_regex ?= \<init\.sh\>
1198
1199 # In tests, use "compare expected actual", not the reverse.
1200 sc_prohibit_reversed_compare_failure:
1201         @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)'                \
1202         containing='$(_test_script_regex)'                              \
1203         halt='reversed compare arguments'                               \
1204           $(_sc_search_regexp)
1205
1206 # #if HAVE_... will evaluate to false for any non numeric string.
1207 # That would be flagged by using -Wundef, however gnulib currently
1208 # tests many undefined macros, and so we can't enable that option.
1209 # So at least preclude common boolean strings as macro values.
1210 sc_Wundef_boolean:
1211         @prohibit='^#define.*(yes|no|true|false)$$'                     \
1212         in_files='$(CONFIG_INCLUDE)'                                    \
1213         halt='Use 0 or 1 for macro values'                              \
1214           $(_sc_search_regexp)
1215
1216 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1217 # not be constant, or might overflow a stack.  In general, use PATH_MAX as
1218 # a limit, not an array or alloca size.
1219 sc_prohibit_path_max_allocation:
1220         @prohibit='(\balloca *\([^)]*|\[[^]]*)\bPATH_MAX'               \
1221         halt='Avoid stack allocations of size PATH_MAX'                 \
1222           $(_sc_search_regexp)
1223
1224 sc_vulnerable_makefile_CVE-2009-4029:
1225         @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1226         in_files='(^|/)Makefile\.in$$'                                  \
1227         halt=$$(printf '%s\n'                                           \
1228           'the above files are vulnerable; beware of running'           \
1229           '  "make dist*" rules, and upgrade to fixed automake'         \
1230           '  see http://bugzilla.redhat.com/542609 for details')        \
1231           $(_sc_search_regexp)
1232
1233 sc_vulnerable_makefile_CVE-2012-3386:
1234         @prohibit='chmod a\+w \$$\(distdir\)'                           \
1235         in_files='(^|/)Makefile\.in$$'                                  \
1236         halt=$$(printf '%s\n'                                           \
1237           'the above files are vulnerable; beware of running'           \
1238           '  "make distcheck", and upgrade to fixed automake'           \
1239           '  see http://bugzilla.redhat.com/CVE-2012-3386 for details') \
1240           $(_sc_search_regexp)
1241
1242 vc-diff-check:
1243         $(AM_V_GEN)(unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1244         $(AM_V_at)if test -s vc-diffs; then                     \
1245           cat vc-diffs;                                         \
1246           echo "Some files are locally modified:" 1>&2;         \
1247           exit 1;                                               \
1248         else                                                    \
1249           rm vc-diffs;                                          \
1250         fi
1251
1252 rel-files = $(DIST_ARCHIVES)
1253
1254 gnulib_dir ?= $(srcdir)/gnulib
1255 gnulib-version = $$(cd $(gnulib_dir) && git describe)
1256 bootstrap-tools ?= autoconf,automake,gnulib
1257
1258 # If it's not already specified, derive the GPG key ID from
1259 # the signed tag we've just applied to mark this release.
1260 gpg_key_ID ?=                                                           \
1261   $$(cd $(srcdir)                                                       \
1262      && git cat-file tag v$(VERSION)                                    \
1263         | gpgv --status-fd 1 --keyring /dev/null - - 2>/dev/null        \
1264         | awk '/^\[GNUPG:\] ERRSIG / {print $$3; exit}')
1265
1266 translation_project_ ?= coordinator@translationproject.org
1267
1268 # Make info-gnu the default only for a stable release.
1269 ifeq ($(RELEASE_TYPE),stable)
1270   announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1271   announcement_mail_headers_ ?=                                         \
1272     To: info-gnu@gnu.org                                                \
1273     Cc: $(announcement_Cc_)                                             \
1274     Mail-Followup-To: $(PACKAGE_BUGREPORT)
1275 else
1276   announcement_Cc_ ?= $(translation_project_)
1277   announcement_mail_headers_ ?=                                         \
1278     To: $(PACKAGE_BUGREPORT)                                            \
1279     Cc: $(announcement_Cc_)
1280 endif
1281
1282 announcement: NEWS ChangeLog $(rel-files)
1283         $(AM_V_GEN)$(srcdir)/$(_build-aux)/announce-gen                 \
1284             --mail-headers='$(announcement_mail_headers_)'              \
1285             --release-type=$(RELEASE_TYPE)                              \
1286             --package=$(PACKAGE)                                        \
1287             --prev=$(PREV_VERSION)                                      \
1288             --curr=$(VERSION)                                           \
1289             --gpg-key-id=$(gpg_key_ID)                                  \
1290             --srcdir=$(srcdir)                                          \
1291             --news=$(srcdir)/NEWS                                       \
1292             --bootstrap-tools=$(bootstrap-tools)                        \
1293             $$(case ,$(bootstrap-tools), in (*,gnulib,*)                \
1294                echo --gnulib-version=$(gnulib-version);; esac)          \
1295             --no-print-checksums                                        \
1296             $(addprefix --url-dir=, $(url_dir_list))
1297
1298 .PHONY: release-commit
1299 release-commit:
1300         $(AM_V_GEN)cd $(srcdir)                         \
1301           && $(_build-aux)/do-release-commit-and-tag    \
1302                -C $(abs_builddir) $(RELEASE)
1303
1304 ## ---------------- ##
1305 ## Updating files.  ##
1306 ## ---------------- ##
1307
1308 ftp-gnu = ftp://ftp.gnu.org/gnu
1309 www-gnu = http://www.gnu.org
1310
1311 upload_dest_dir_ ?= $(PACKAGE)
1312 emit_upload_commands:
1313         @echo =====================================
1314         @echo =====================================
1315         @echo "$(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \\"
1316         @echo "    --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1317         @echo "  $(rel-files)"
1318         @echo '# send the ~/announce-$(my_distdir) e-mail'
1319         @echo =====================================
1320         @echo =====================================
1321
1322 define emit-commit-log
1323   printf '%s\n' 'maint: post-release administrivia' ''                  \
1324     '* NEWS: Add header line for next release.'                         \
1325     '* .prev-version: Record previous version.'                         \
1326     '* cfg.mk (old_NEWS_hash): Auto-update.'
1327 endef
1328
1329 .PHONY: no-submodule-changes
1330 no-submodule-changes:
1331         $(AM_V_GEN)if test -d $(srcdir)/.git; then                      \
1332           diff=$$(cd $(srcdir) && git submodule -q foreach              \
1333                   git diff-index --name-only HEAD)                      \
1334             || exit 1;                                                  \
1335           case $$diff in '') ;;                                         \
1336             *) echo '$(ME): submodule files are locally modified:';     \
1337                 echo "$$diff"; exit 1;; esac;                           \
1338         else                                                            \
1339           : ;                                                           \
1340         fi
1341
1342 submodule-checks ?= no-submodule-changes public-submodule-commit
1343
1344 # Ensure that each sub-module commit we're using is public.
1345 # Without this, it is too easy to tag and release code that
1346 # cannot be built from a fresh clone.
1347 .PHONY: public-submodule-commit
1348 public-submodule-commit:
1349         $(AM_V_GEN)if test -d $(srcdir)/.git; then                      \
1350           cd $(srcdir) &&                                               \
1351           git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1352               = '$$(git merge-base origin $$sha1)'                      \
1353             || { echo '$(ME): found non-public submodule commit' >&2;   \
1354                  exit 1; };                                             \
1355         else                                                            \
1356           : ;                                                           \
1357         fi
1358 # This rule has a high enough utility/cost ratio that it should be a
1359 # dependent of "check" by default.  However, some of us do occasionally
1360 # commit a temporary change that deliberately points to a non-public
1361 # submodule commit, and want to be able to use rules like "make check".
1362 # In that case, run e.g., "make check gl_public_submodule_commit="
1363 # to disable this test.
1364 gl_public_submodule_commit ?= public-submodule-commit
1365 check: $(gl_public_submodule_commit)
1366
1367 .PHONY: alpha beta stable
1368 ALL_RECURSIVE_TARGETS += alpha beta stable
1369 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1370         $(AM_V_GEN)test $@ = stable                                     \
1371           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$'         \
1372                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1373           || :
1374         $(AM_V_at)$(MAKE) vc-diff-check
1375         $(AM_V_at)$(MAKE) news-check
1376         $(AM_V_at)$(MAKE) distcheck
1377         $(AM_V_at)$(MAKE) dist
1378         $(AM_V_at)$(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1379         $(AM_V_at)$(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1380
1381 # Override this in cfg.mk if you follow different procedures.
1382 release-prep-hook ?= release-prep
1383
1384 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1385 .PHONY: release-prep
1386 release-prep:
1387         $(AM_V_GEN)case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1388           *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1389         $(AM_V_at)$(MAKE) --no-print-directory -s announcement \
1390           > ~/announce-$(my_distdir)
1391         $(AM_V_at)if test -d $(release_archive_dir); then       \
1392           ln $(rel-files) $(release_archive_dir);               \
1393           chmod a-w $(rel-files);                               \
1394         fi
1395         $(AM_V_at)echo $(VERSION) > $(prev_version_file)
1396         $(AM_V_at)$(MAKE) update-NEWS-hash
1397         $(AM_V_at)perl -pi                                              \
1398           -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"'        \
1399           $(srcdir)/NEWS
1400         $(AM_V_at)msg=$$($(emit-commit-log)) || exit 1;         \
1401         cd $(srcdir) && $(VC) commit -m "$$msg" -a
1402
1403 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1404 # if the default $(PACKAGE)-derived name doesn't apply.
1405 gendocs_options_ ?=
1406
1407 .PHONY: web-manual
1408 web-manual:
1409         $(AM_V_GEN)test -z "$(manual_title)" \
1410           && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1411         $(AM_V_at)cd '$(srcdir)/doc'; \
1412           $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
1413              -o '$(abs_builddir)/doc/manual' \
1414              --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1415             "$(PACKAGE_NAME) - $(manual_title)"
1416         $(AM_V_at)echo " *** Upload the doc/manual directory to web-cvs."
1417
1418 .PHONY: web-manual-update
1419 web-manual-update:
1420         $(AM_V_GEN)cd $(srcdir) \
1421           && $(_build-aux)/gnu-web-doc-update -C $(abs_builddir)
1422
1423
1424 # Code Coverage
1425
1426 init-coverage:
1427         $(MAKE) $(AM_MAKEFLAGS) clean
1428         lcov --directory . --zerocounters
1429
1430 COVERAGE_CCOPTS ?= "-g --coverage"
1431 COVERAGE_OUT ?= doc/coverage
1432
1433 build-coverage:
1434         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1435         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1436         mkdir -p $(COVERAGE_OUT)
1437         lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1438                 --capture
1439
1440 gen-coverage:
1441         genhtml --output-directory $(COVERAGE_OUT) \
1442                 $(COVERAGE_OUT)/$(PACKAGE).info \
1443                 --highlight --frames --legend \
1444                 --title "$(PACKAGE_NAME)"
1445
1446 coverage: init-coverage build-coverage gen-coverage
1447
1448 # Some projects carry local adjustments for gnulib modules via patches in
1449 # a gnulib patch directory whose default name is gl/ (defined in bootstrap
1450 # via local_gl_dir=gl).  Those patches become stale as the originals evolve
1451 # in gnulib.  Use this rule to refresh any stale patches.  It applies each
1452 # patch to the original in $(gnulib_dir) and uses the temporary result to
1453 # generate a fuzz-free .diff file.  If you customize the name of your local
1454 # gnulib patch directory via bootstrap.conf, this rule detects that name.
1455 # Run this from a non-VPATH (i.e., srcdir) build directory.
1456 .PHONY: refresh-gnulib-patches
1457 refresh-gnulib-patches:
1458         gl=gl;                                                          \
1459         if test -f bootstrap.conf; then                                 \
1460           t=$$(perl -lne '/^\s*local_gl_dir=(\S+)/ and $$d=$$1;'        \
1461                -e 'END{defined $$d and print $$d}' bootstrap.conf);     \
1462           test -n "$$t" && gl=$$t;                                      \
1463         fi;                                                             \
1464         for diff in $$(cd $$gl; git ls-files | grep '\.diff$$'); do     \
1465           b=$$(printf %s "$$diff"|sed 's/\.diff$$//');                  \
1466           VERSION_CONTROL=none                                          \
1467             patch "$(gnulib_dir)/$$b" "$$gl/$$diff" || exit 1;          \
1468           ( cd $(gnulib_dir) || exit 1;                                 \
1469             git diff "$$b" > "../$$gl/$$diff";                          \
1470             git checkout $$b ) || exit 1;                               \
1471         done
1472
1473 # Update gettext files.
1474 PACKAGE ?= $(shell basename $(PWD))
1475 PO_DOMAIN ?= $(PACKAGE)
1476 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1477 PODIR ?= po
1478 refresh-po:
1479         rm -f $(PODIR)/*.po && \
1480         echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1481         wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1482         echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1483         echo 'en@quot' >> $(PODIR)/LINGUAS && \
1484         ls $(PODIR)/*.po | sed 's/\.po//;s,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1485
1486  # Running indent once is not idempotent, but running it twice is.
1487 INDENT_SOURCES ?= $(C_SOURCES)
1488 .PHONY: indent
1489 indent:
1490         indent $(INDENT_SOURCES)
1491         indent $(INDENT_SOURCES)
1492
1493 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1494 # put the assignments in this variable.
1495 update-copyright-env ?=
1496
1497 # Run this rule once per year (usually early in January)
1498 # to update all FSF copyright year lists in your project.
1499 # If you have an additional project-specific rule,
1500 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1501 # By default, exclude all variants of COPYING; you can also
1502 # add exemptions (such as ChangeLog..* for rotated change logs)
1503 # in the file .x-update-copyright.
1504 .PHONY: update-copyright
1505 update-copyright:
1506         $(AM_V_GEN)grep -l -w Copyright                                  \
1507           $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1508           | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
1509
1510 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1511 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1512
1513 # NOTE: to override any _gl_TS_* default value, you must
1514 # define the variable(s) using "export" in cfg.mk.
1515 _gl_TS_dir ?= src
1516
1517 ALL_RECURSIVE_TARGETS += sc_tight_scope
1518 sc_tight_scope: tight-scope.mk
1519         @fail=0;                                                        \
1520         if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk        \
1521                 > /dev/null                                             \
1522            && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1523                 > /dev/null 2>&1; then                                  \
1524             echo '$(ME): skipping $@';                                  \
1525         else                                                            \
1526             $(MAKE) -s -C $(_gl_TS_dir)                                 \
1527                 -f Makefile                                             \
1528                 -f $(abs_top_srcdir)/cfg.mk                             \
1529                 -f $(abs_top_builddir)/$<                               \
1530               _gl_tight_scope                                           \
1531                 || fail=1;                                              \
1532         fi;                                                             \
1533         rm -f $<;                                                       \
1534         exit $$fail
1535
1536 tight-scope.mk: $(ME)
1537         @rm -f $@ $@-t
1538         @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
1539         @chmod a=r $@-t && mv $@-t $@
1540
1541 ifeq (a,b)
1542 # TS-start
1543
1544 # Most functions should have static scope.
1545 # Any that don't must be marked with 'extern', but 'main'
1546 # and 'usage' are exceptions: they're always extern, but
1547 # do not need to be marked.  Symbols matching '__.*' are
1548 # reserved by the compiler, so are automatically excluded below.
1549 _gl_TS_unmarked_extern_functions ?= main usage
1550 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) *\(/
1551
1552 # If your project uses a macro like "XTERN", then put
1553 # the following in cfg.mk to override this default:
1554 # export _gl_TS_extern = extern|XTERN
1555 _gl_TS_extern ?= extern
1556
1557 # The second nm|grep checks for file-scope variables with 'extern' scope.
1558 # Without gnulib's progname module, you might put program_name here.
1559 # Symbols matching '__.*' are reserved by the compiler,
1560 # so are automatically excluded below.
1561 _gl_TS_unmarked_extern_vars ?=
1562
1563 # NOTE: the _match variables are perl expressions -- not mere regular
1564 # expressions -- so that you can extend them to match other patterns
1565 # and easily extract matched variable names.
1566 # For example, if your project declares some global variables via
1567 # a macro like this: GLOBAL(type, var_name, initializer), then you
1568 # can override this definition to automatically extract those names:
1569 # export _gl_TS_var_match = \
1570 #   /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1571 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1572
1573 # The names of object files in (or relative to) $(_gl_TS_dir).
1574 _gl_TS_obj_files ?= *.$(OBJEXT)
1575
1576 # Files in which to search for the one-line style extern declarations.
1577 # $(_gl_TS_dir)-relative.
1578 _gl_TS_headers ?= $(noinst_HEADERS)
1579 _gl_TS_other_headers ?= *.h
1580
1581 .PHONY: _gl_tight_scope
1582 _gl_tight_scope: $(bin_PROGRAMS)
1583         t=exceptions-$$$$;                                              \
1584         trap 's=$$?; rm -f $$t; exit $$s' 0;                            \
1585         for sig in 1 2 3 13 15; do                                      \
1586           eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1587         done;                                                           \
1588         src=`for f in $(SOURCES); do                                    \
1589                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1590         hdr=`for f in $(_gl_TS_headers); do                             \
1591                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1592         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions);  \
1593           grep -h -A1 '^extern .*[^;]$$' $$src                          \
1594             | grep -vE '^(extern |--)' | sed 's/ .*//';                 \
1595           perl -lne                                                     \
1596              '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr;      \
1597         ) | sort -u > $$t;                                              \
1598         nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
1599           && { echo the above functions should have static scope >&2;   \
1600                exit 1; } || : ;                                         \
1601         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars);       \
1602           perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"'           \
1603                 $$hdr $(_gl_TS_other_headers)                           \
1604         ) | sort -u > $$t;                                              \
1605         nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p'          \
1606             | sort -u | grep -Ev -f $$t                                 \
1607           && { echo the above variables should have static scope >&2;   \
1608                exit 1; } || :
1609 # TS-end
1610 endif